#include <math.h>
#include <SDL.h>
#include <SDL_image.h>
#include <SDL_thread.h>

#include "main.h"
#include "linedraw.h"
#include "find_image.h"

static float lp[MAX_METERS];

void load_graphics_vu()
{
	meter = find_image("vu-frame-small.png");
	meter_buf = find_image("vu-frame-small.png");
}

int gfx_thread_vu(void *foo)
{
	int x1, y1, x2, y2, i;
	const float angle_scale = 1.13f;
	const float angle_offset = 0.88f;
	const float needle_len = 100.0f;
	const float needle_hub = 20.0f;
	const Uint32 needle = SDL_MapRGB(meter->format, 0x70, 0x70, 0x70);
	const Uint32 aa = SDL_MapRGB(meter->format, 0xC0, 0xC0, 0x60);
	float theta;
	SDL_Rect buf_rect[MAX_METERS];

	for (i=0; i<num_meters; i++) {
		lp[i] = 0.0f;
		buf_rect[i].x = dest[i].x + 30;
		buf_rect[i].y = dest[i].y + 70;
		buf_rect[i].w = 170;
		buf_rect[i].h = 86;
printf("%d,%d, %dx%d\n", buf_rect[i].x, buf_rect[i].y, buf_rect[i].w, buf_rect[i].h);
	}

	while (1) {
		for (i=0; i<num_meters; i++) {
			lp[i] = lp[i] * 0.7f + env[i] * bias * 0.3f;
			theta = (lp[i] * angle_scale) - angle_offset;

			if (theta < -0.74f) theta = -0.74f;
			if (theta > 0.74f) theta = 0.74f;
			x1 = 110 + (int)(sinf(theta) * needle_hub);
			y1 = 169 - (int)(cosf(theta) * needle_hub);
			x2 = 110 + (int)(sinf(theta) * needle_len);
			y2 = 169 - (int)(cosf(theta) * needle_len);

			SDL_BlitSurface(meter, buf_rect, meter_buf, buf_rect);
			draw_ptr(meter_buf, x1, y1, x2, y2, needle, aa);
			SDL_BlitSurface(meter_buf, buf_rect, screen, buf_rect+i);
		}
		SDL_UpdateRects(screen, 1, &win);
		SDL_Delay(50);
	}

	return 0;
}
